;******************************************************************************
;*                                                                            *
;* Guillermito Cube Mod v1 - Jan 2006 - http://www.guillermito2.net           *
;*                   [copyleft and open source]                               *
;*                                                                            *
;* A small utility to change only the boot logo in the Mobiblu DAH-1500i cube *
;* MP3 player. At this time, the only firmware that it will change is the     *
;* latest, v100.100.105. If they upgrade the firmware, it will probably       *
;* need some tweaking.                                                        *
;*                                                                            *
;* You just have to follow the 4 steps, as described.                         *
;*                                                                            *
;* Of course, you should backup your 'resource.bin' file before in case of    *
;* problem (my program does not come with any warranty). At the end, you      *
;* will also have to upate the firmware manually with the Mobiblu tool,       *
;* which is by default at c:\Program Files\MP3 Update.                        *
;*                                                                            *
;* Maybe if I have some time I will do another one to easily change the       *
;* two animations (boot and switch off). Have fun.                            *
;*                                                                            *
;* By the way, this source is a mess, I didn't spent time polishing it. But   *
;* it works fine.                                                             *
;*                                                                            *
;* Compile ressource: gorc.exe /r gcubemod.rc                                 *
;*          Assemble: tasm32 /ml /m3 /z /t gcubemod                           *
;*              Link: tlink32 -Tpe -aa gcubemod,,,import32,,gcubemod.res      *
;*          Compress: upx -9 gcubemod.exe                                     *
;*                                                                            *
;****************************************************************************** 

callW macro x
extrn x:PROC
call x
endm

.486
.model flat

.data

openfilename_struct:
lStructSize        dd openfilename_struct_size
hwndOwner          dd 0
hInstance          dd 0
lpstrFilter        dd ?
lpstrCustomFilter  dd 0
nMaxCustFilter     dd 0
nFilterIndex       dd 0
lpstrFile          dd ?
nMaxFile           dd 255
lpstrFileTitle     dd 0
nMaxFileTitle      dd 32
lpstrInitialDir    dd 0
lpstrTitle         dd 0
Flags              dd 1000h+4h+200000h
nFileOffset        dw 0
nFileExtension     dw 0
lpstrDefExt        dd 0
lCustData          dd 0
lpfnHook           dd 0
lpTemplateName     dd 0
openfilename_struct_size equ $-offset openfilename_struct
filter_bin         db "Mobiblu firmware file",0,"resource.bin",0
                   db "All files",0,"*.*",0,0
filter_bmp         db "64x48 24-bits Bitmap file",0,"*.bmp",0
                   db "All files",0,"*.*",0,0
namebuffer_bin     db 255 dup(0)
namebuffer_bmp     db 255 dup(0)

modhandle          dd ?
dialog_name        db "dialogue",0
hWnd               dd ?
uMsg               dd ?
wParam             dd ?
file_handle        dd ?
file_size          dd ?
fmw_mem_buffer     dd ?
bmp_mem_buffer     dd ?
file_nb_bytes_read dd ?
pixels_data_start  dd ?
encode_mem_buffer  dd ?
encode_size        dd ?
y_counter          dd ?
titlebox           db "Guillermito Cube Mod v1",0
prob_firmware      db "Firmware has a bad size or version signature,",0dh,0ah
                   db "or there was a general read/memory problem",0
prob_bitmap        db "Bitmap is not 64x48 pixels or 24-bits (means 16.7 millions colors),",0dh,0ah
                   db "or there was a general read/memory problem",0
prob_save          db "There seems to be a general problem saving the new firmware",0
sig_firmware       db "Product Version: 100.100.105",0dh,0ah
                   db "Component Version: 002.511.100",0dh,0ah
size_sig equ $-offset sig_firmware

.code

CODE_POETRY:

;************************************************************************
;*********************  MAIN ROUTINE  ***********************************
;************************************************************************

;--------- get handle ---------------------

push 0
callW GetModuleHandleA
mov modhandle, eax

;--------- show dialog box --------------

push 0
push offset dialog_proc
push 0
push offset dialog_name
push modhandle
callW DialogBoxParamA

;---------- terminate ------------

push -1
callW ExitProcess 

;************************************************************************
;*********************  DIALOG PROCEDURE  *******************************
;************************************************************************

dialog_proc:
pusha
push ebp
mov ebp, esp
mov eax, [ebp+8+20h]    ;hWnd
mov hWnd, eax
mov eax, [ebp+12+20h]   ;uMsg
mov uMsg, eax
mov eax, [esp+16+20h]   ;wParam
mov wParam, eax

;-------------- if the dialog is closed --------------

cmp uMsg, 10h                           ;WM_CLOSE
jne no_end

push 0
push hWnd
callW EndDialog

jmp end_dlgproc_return_1

;--------------- if the dialog is started --------------

no_end:
cmp uMsg, 110h                         ;WM_INITDIALOG
jne no_start

jmp end_dlgproc_return_1  

;-------------- if there is a command sent to the dialog --------------

no_start:
cmp uMsg, 111h                         ;WM_COMMAND  
je there_is_a_command
jmp end_dlgproc_return_0  
there_is_a_command:

;************************************************************************
;*********************  1. FIND FIRMWARE  *******************************
;************************************************************************

cmp wParam, 200                        ;button no1
je find_firmware
jmp check_button2
find_firmware:

;-------- choose a file -------------

mov lpstrFilter, offset filter_bin
mov lpstrFile, offset namebuffer_bin
push offset openfilename_struct
callW GetOpenFileNameA             ;choose file
test eax, eax
jnz choose_ok
jmp firmware_problem
choose_ok:

;-------- open it --------------

push 0
push 80h                          ;FILE_ATTRIBUTE_NORMAL
push 3                            ;OPEN_EXISTING
push 0
push 0
push 80000000h+40000000h          ;GENERIC_READ+GENERIC_WRITE
push dword ptr [lpstrFile]
callW CreateFileA                 ;open file
inc eax
jnz open_ok
jmp firmware_problem
open_ok:
dec eax
mov file_handle, eax

;---------- get its size ---------

push 0
push dword ptr file_handle
callW GetFileSize                 ;get file size in bytes
inc eax
jnz size_ok
jmp firmware_problem
size_ok:
dec eax
mov file_size, eax

;--------- alloc memory for file --------

mov eax, file_size
add eax, 1024
push eax                         ;number of bytes to allocate
push 40h                         ;40h=LMEM_ZEROINIT
callW LocalAlloc
test eax, eax
jnz alloc_ok
jmp firmware_problem
alloc_ok:
mov fmw_mem_buffer, eax

;------- read entire file ------------

push 0
push offset file_nb_bytes_read
push file_size
push fmw_mem_buffer
push file_handle
callW ReadFile
test eax, eax
jnz read_ok
jmp firmware_problem
read_ok:
mov eax, file_nb_bytes_read
cmp eax, file_size
jz size_read_OK
jmp firmware_problem
size_read_OK:

;-------- check if size is same -----------

cmp file_size, 3294102
jz size_OK
jmp firmware_problem
size_OK:

;------- close it ----------------

push file_handle
callW CloseHandle
test eax, eax
jnz close_ok
jmp firmware_problem
close_ok:

;-------- check firmware signature ---------

mov esi, fmw_mem_buffer
mov edi, offset sig_firmware
mov ecx, size_sig
repz cmpsb
jz sig_OK
jmp firmware_problem
sig_OK:

;---------- disable step 1 -------------

push 200
push hWnd
callW GetDlgItem
push 0
push eax
callW EnableWindow

;---------- enable step 2 -------------

push 201
push hWnd
callW GetDlgItem
push 1
push eax
callW EnableWindow

jmp end_dlgproc_return_0

;-------- firmware problem -----------

firmware_problem:
push 0
push offset titlebox
push offset prob_firmware
push hWnd
callW MessageBoxA

jmp end_dlgproc_return_0

;************************************************************************
;*********************  2. FIND BITMAP  *********************************
;************************************************************************

check_button2:
cmp wParam, 201                    ;button no2
je find_bmp
jmp check_button3
find_bmp:

;-------- choose a file -------------

mov lpstrFilter, offset filter_bmp
mov lpstrFile, offset namebuffer_bmp
push offset openfilename_struct
callW GetOpenFileNameA             ;choose file
test eax, eax
jnz choose_ok2
jmp bmp_problem
choose_ok2:

;-------- open it --------------

push 0
push 80h                          ;FILE_ATTRIBUTE_NORMAL
push 3                            ;OPEN_EXISTING
push 0
push 0
push 80000000h+40000000h          ;GENERIC_READ+GENERIC_WRITE
push dword ptr [lpstrFile]
callW CreateFileA                 ;open file
inc eax
jnz open_ok2
jmp bmp_problem
open_ok2:
dec eax
mov file_handle, eax

;---------- get its size ---------

push 0
push dword ptr file_handle
callW GetFileSize                 ;get file size in bytes
inc eax
jnz size_ok2
jmp bmp_problem
size_ok2:
dec eax
mov file_size, eax

;--------- alloc memory for file --------

mov eax, file_size
add eax, 1024
push eax                         ;number of bytes to allocate
push 40h                         ;40h=LMEM_ZEROINIT
callW LocalAlloc
test eax, eax
jnz alloc_ok2
jmp bmp_problem
alloc_ok2:
mov bmp_mem_buffer, eax

;------- read entire file ------------

push 0
push offset file_nb_bytes_read
push file_size
push bmp_mem_buffer
push file_handle
callW ReadFile
test eax, eax
jnz read_ok2
jmp bmp_problem
read_ok2:
mov eax, file_nb_bytes_read
cmp eax, file_size
jz size_read_OK2
jmp bmp_problem
size_read_OK2:

;------- close it ----------------

push file_handle
callW CloseHandle
test eax, eax
jnz close_ok2
jmp bmp_problem
close_ok2:

;-------- find BMP signature ---------

mov esi, bmp_mem_buffer
lodsw
cmp ax, "MB"
je bm_ok
jmp bmp_problem
bm_ok:

;------- find size and number of bits per pixel ------

add esi, 8
lodsd
add eax, bmp_mem_buffer
mov pixels_data_start, eax
add esi, 4
lodsd
cmp eax, 64d
je x_ok
jmp bmp_problem
x_ok:
lodsd
cmp eax, 48d
je y_ok
jmp bmp_problem
y_ok:
add esi, 2
lodsw
cmp ax, 24d
je this_looks_like_a_good_bmp
jmp bmp_problem

;------ Encode BMP into Nokia/Mobiblu format -----------

this_looks_like_a_good_bmp:
mov eax, bmp_mem_buffer
add eax, file_size
mov encode_mem_buffer, eax

mov y_counter, 6
mov esi, pixels_data_start
add esi, 3*64*40
mov edi, encode_mem_buffer

parse_image:
mov ecx, 64
push esi

parse_one_block_of_8_lines:
xor eax, eax
cmp byte ptr [esi], 127
jb next1
inc al
next1:
rol al, 1
cmp byte ptr [esi+(64*3)], 127
jb next2
inc al
next2:
rol al, 1
cmp byte ptr [esi+(64*3)*2], 127
jb next3
inc al
next3:
rol al, 1
cmp byte ptr [esi+(64*3)*3], 127
jb next4
inc al
next4:
rol al, 1
cmp byte ptr [esi+(64*3)*4], 127
jb next5
inc al
next5:
rol al, 1
cmp byte ptr [esi+(64*3)*5], 127
jb next6
inc al
next6:
rol al, 1
cmp byte ptr [esi+(64*3)*6], 127
jb next7
inc al
next7:
rol al, 1
cmp byte ptr [esi+(64*3)*7], 127
jb next8
inc al
next8:

stosb
add esi, 3
loop parse_one_block_of_8_lines

next_block:
pop esi
sub esi, 64*3*8 
dec y_counter
jz finish_encoding
jmp parse_image

finish_encoding:
mov eax, edi
sub eax, encode_mem_buffer
mov encode_size, eax

;------- check if it's 384 bytes long ----------

cmp encode_size, 384
jnz bmp_problem 

;----------- replace boot logo in memory ------------

mov esi, encode_mem_buffer
mov edi, fmw_mem_buffer
add edi, 283284             ;offset of the boot logo image in the firmware
mov ecx, 384
rep movsb

;---------- disable step 2 -------------

push 201
push hWnd
callW GetDlgItem
push 0
push eax
callW EnableWindow

;---------- enable step 3 -------------

push 202
push hWnd
callW GetDlgItem
push 1
push eax
callW EnableWindow

jmp end_dlgproc_return_0

;-------- bmp problem -----------

bmp_problem:
push 0
push offset titlebox
push offset prob_bitmap
push hWnd
callW MessageBoxA

jmp end_dlgproc_return_0

;************************************************************************
;******************  3. SAVE NEW FIRMWARE  ******************************
;************************************************************************

check_button3:
cmp wParam, 202                    ;button no3
je save_fw
jmp check_button4
save_fw:

;------- open a new file on the disk ----------------

push 0                     ;handle of file with attributes to copy 
push 80h                   ;file attributes (80h=FILE_ATTRIBUTE_NORMAL)
push 2                     ;how to create (2=CREATE_ALWAYS)
push 0                     ;address of security descriptor 
push 0                     ;share mode (0=Prevents the file from being shared)
push 40000000h             ;access (read-write) mode (40000000h=GENERIC_WRITE)
push offset namebuffer_bin ;address of name of the file
call CreateFileA
inc eax
jnz open_ok3
jmp save_problem
open_ok3:
dec eax
mov file_handle, eax

;------- write buffer in it ----------------

push 0
push offset file_nb_bytes_read          ;address of number of bytes written 
push 3294102                            ;number of bytes to write
push fmw_mem_buffer                     ;address of data to write to file
push file_handle                        ;handle of file to write to
callW WriteFile
test eax, eax
jnz write_ok
jmp save_problem
write_ok:
mov eax, file_nb_bytes_read
cmp eax, 3294102
jz size_write_ok
jmp save_problem
size_write_ok:

;------- close it ----------------

push file_handle
callW CloseHandle
test eax, eax
jnz close_ok3
jmp save_problem
close_ok3:

;------- close memory ----------------

push fmw_mem_buffer
callW LocalFree
push bmp_mem_buffer
callW LocalFree

;---------- disable step 3 -------------

push 202
push hWnd
callW GetDlgItem
push 0
push eax
callW EnableWindow

;---------- enable step 4 -------------

push 203
push hWnd
callW GetDlgItem
push 1
push eax
callW EnableWindow

jmp end_dlgproc_return_0

;-------- save problem -----------

save_problem:
push 0
push offset titlebox
push offset prob_save
push hWnd
callW MessageBoxA

jmp end_dlgproc_return_0

;************************************************************************
;***********************  4. QUIT  **************************************
;************************************************************************

check_button4:
cmp wParam, 203                    ;button no4
je ze_end
jmp end_dlgproc_return_0
ze_end:

push 0
push hWnd
callW EndDialog
jmp end_dlgproc_return_1

;--------- end dialog proc -----------------

end_dlgproc_return_0:
leave
popa
xor eax, eax
ret 16

end_dlgproc_return_1:
leave
popa
xor eax, eax
inc eax
ret 16

end CODE_POETRY
